'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var LANG_PACK = {
  'en-us': {
    items_per_page: '/Page',
    jump_to: 'Page',
    page: '',
    total: function total(_total) {
      return 'Total ' + _total + ' items';
    },
    item: ' entries',
    pageNo: function pageNo(page) {
      return 'Page ' + page;
    },
    ok: 'Go'
  },
  'zh-cn': {
    items_per_page: '条/页',
    jump_to: '跳至',
    page: '页',
    total: function total(_total2) {
      return '\u5171 ' + _total2 + ' \u6761';
    },
    item: '条',
    pageNo: function pageNo(page) {
      return '\u7B2C ' + page + ' \u9875';
    },
    ok: '确定'
  },
  'zh-hk': {
    items_per_page: '條/頁',
    jump_to: '跳至',
    page: '頁',
    total: function total(_total3) {
      return '\u5171 ' + _total3 + ' \u689D';
    },
    item: '條',
    pageNo: function pageNo(page) {
      return '\u7B2C ' + page + ' \u9801';
    },
    ok: '確定'
  }
};
LANG_PACK.en = LANG_PACK['en-us'];
LANG_PACK['en_US'] = LANG_PACK['en-us'];
LANG_PACK['zh_CN'] = LANG_PACK['zh-cn'];

exports["default"] = LANG_PACK;
module.exports = exports['default'];